mobjinfo[MT_ENERGYAURA] = {
	spawnstate = S_MSSHIELD_F1,
	dispoffset = 2,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY
}
addHook("MobjThinker", function(mo) CMS.MetalAura(mo,mo.target) end, MT_ENERGYAURA)

mobjinfo[MT_ENERGYGATHER] = {
	spawnstate = S_JETFUME1,
	dispoffset = -1,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY
}
addHook("MobjThinker", function(mo) CMS.EnergyGather(mo,mo.target,mo.extravalue1,mo.extravalue2) end,MT_ENERGYGATHER)

//Finally, aura
mobjinfo[MT_CMS_SUPERAURA] = {
	doomednum = -1,
	spawnstate = S_CMS_SUPERAURA,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP,
	dispoffset = -4,
	radius = 5*FRACUNIT,
	height = 30*FRACUNIT,
	deathsound = sfx_ncspec
}
states[S_CMS_SUPERAURA] = {
	sprite = SPR_CMAU,
	frame = FF_TRANS50|FF_FULLBRIGHT|FF_ANIMATE,
	var1 = 1,
	var2 = 3
}
addHook("MobjThinker", CMS.MetalSuperAura, MT_CMS_SUPERAURA)

CMS.AimThinker = function(p)
	if p.mo.skin != "cosmetal" then return end
	if p.spectator then return end
	local cms = p.cms
	
	if cms.dashmode.activated
		if p.pflags&PF_STARTDASH then return true end
		
		if P_IsObjectOnGround(p.mo)
		and p.mo.state != S_PLAY_METALAIM
		and not(p.pflags & (PF_USEDOWN))
			if CMS.Check("newaim")
				P_InstaThrust(p.mo, p.drawangle, 0)
			else
				p.mo.cmomx = 5 * cos(p.mo.angle)
				p.mo.cmomy = 5 * sin(p.mo.angle)
			end
			p.dashspeed = p.speed
			S_StartSound(p.mo, sfx_s3k5a)
			p.mo.state = S_PLAY_METALAIM
			p.pflags = $|PF_STARTDASH|PF_USEDOWN|PF_SPINNING
			return true
		end
	end
end
CMS.PlayerThink = function(p)
	if p.mo.skin != "cosmetal" then return end
	local cms = p.cms
	if p.mo.state != S_PLAY_METALAIM
		p.spinitem = MT_THOK
		p.revitem = MT_SPINDUST
	else
		p.spinitem = MT_NULL
		p.revitem = MT_NULL
	end
	if cms.dashmode.activated
		if p.pflags&PF_SPINNING
		and not(p.pflags & (PF_STARTDASH))
		and P_IsObjectOnGround(p.mo)
			p.pflags = $ & ~PF_SPINNING
			p.mo.state = S_PLAY_DASH
		end
	end
end
addHook("SpinSpecial", CMS.AimThinker)
addHook("PlayerThink", CMS.PlayerThink)

local daheg = 0
addHook("MobjThinker", function(mo)
    if not mo.source return end
    mo.lifetime = $ or 0
    --mo.x = mo.source.x + mo.lifetime * mo.momx
    --mo.y = mo.source.y + mo.lifetime * mo.momy
    --mo.z = mo.source.z + mo.lifetime * mo.momz
	if P_MobjFlip(mo.source) == -1
		daheg = -mo.source.height/2
	else
		daheg = mo.source.height/2
	end
	if SUBVERSION > 10
		P_MoveOrigin(mo, mo.source.x + mo.lifetime * mo.momx, mo.source.y + mo.lifetime * mo.momy, mo.source.z + daheg + mo.lifetime * mo.momz)
    else
		P_TeleportMove(mo, mo.source.x + mo.lifetime * mo.momx, mo.source.y + mo.lifetime * mo.momy, mo.source.z + daheg + mo.lifetime * mo.momz)
	end
	mo.lifetime = $ + 1
end, MT_BOXSPARKLE)